<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Collaborator extends MX_Controller {

    public function __construct() {
        parent::__construct();
        $this->load->helper('cookie');
    }

    public function index() {
        $data = array();
        $admin_info = $this->session->userdata('adminInfo');
        if ($admin_info) {
            $data['content'] = $this->getCollaborators();
            $this->load->view('collaborator/index', $data);
        } else {
            $this->load->view('login');
        }
    }

    public function getCollaborators($filters = array()) {
        $this->load->helper('pagging');
        $this->load->model('collabolator_model');
        $data['current_page'] = $this->uri->segment(4, 1);
        $data['itemsoptions'] = array(10, 25, 50, 100);
        $data['perpage'] = 10;
        $data['keyword'] = "";
        $data['sorting_order']="sorting_desc";
        $data['sorting_field']="created_time";
        
        if ($this->input->post('sorting_order')) {
            if ($this->input->post('sorting_order') != "sorting")
            {
               $data['sorting_order']=$this->input->post('sorting_order');
               $data['sorting_field']=$this->input->post('sorting_field'); 
            }
        }
        if ($this->input->post('items')) {
            $data['perpage'] = $this->input->post('items');
        }
        if ($this->input->post('keyword')) {
            $data['keyword'] = $this->input->post('keyword');
        }
        
        $data['start'] = ($data['current_page'] - 1) * $data['perpage'];
        $data['total'] = $this->collabolator_model->countCollaborator($data);  
        $data['collaborators'] = $this->collabolator_model->getCollaborator($data);

        $data['paging_url'] = base_url() . "/admin/cong_tac_vien/trang/";
        $data['num_links'] = 2;
        $data['paging'] = pagging($data);

        if ($this->input->is_ajax_request()) {
            return $this->load->view('collaborator/listview', $data);
        }
        return $this->load->view('collaborator/listview', $data, true);
    }

    public function addCollaborator() {
        $result['success'] = 0;
        $result = array();
        $input = $this->input->post();
        $this->load->model('collabolator_model');
        if (strlen($input['full_name'])==0)
        {
            $result['errors'][]="Tên cộng tác viên không được để trống";
        }
        if (strlen($input['login_name'])==0)
        {
            $result['errors'][]="Tên đăng nhập không được để trống";
        }
        else
        {
            if ($this->collabolator_model->isExist(array('field'=>'login_name','value'=>$input['login_name'])))
            {
                $result['errors'][]="Tên đăng nhập đã được sử dụng";
            }
        }
        if (strlen($input['cellphone'])==0)
        {
            $result['errors'][]="Số điện thoại không được để trống";
        }
        else
        {
            if ($this->collabolator_model->isExist(array('field'=>'cellphone','value'=>$input['cellphone'])))
            {
                $result['errors'][]="Số điện thoại đã được sử dụng";
            }
        }
        if (strlen($input['passwd'])==0)
        {
            $result['errors'][]="Mật khẩu không được để trống";
        }
        if ($input['passwd'] != $input['passwd2'])
        {
            $result['errors'][]="Mật khẩu không trùng nhau";
        }
        if (!isset($result['errors']))
        {
            unset($input['passwd2']);
            $input['activated']=1;
            $input['created_time']=date("Y-m-d H:i:s");
            $input['updated_time']=date("Y-m-d H:i:s");
            $this->load->model('collabolator_model');
            $this->collabolator_model->insert($input);
            $result['success'] = 1;
        }

        
        echo json_encode($result);
    }

    public function test() {
        
        $this->load->library('doctrine');
        for ($i = 1; $i <= 500; $i++) {
            $collaborator = new Entities\Tblcollaborator();
            $collaborator->setActivated(rand(0, 1));
            $collaborator->setAuthor(1);
            $collaborator->setCellphone('0' . (1695061706 + $i));
            $collaborator->setCreatedTime(date("Y-m-d H:i:s"));
            $collaborator->setFullName("Full Name " . $i);
            $collaborator->setLoginName("loginname" . $i);
            $collaborator->setPasswd(md5("12345678"));
            $collaborator->setUpdatedTime(date("Y-m-d H:i:s"));
            try {
                $this->doctrine->em->persist($collaborator);
                $this->doctrine->em->flush();
                $result['success'] = 1;
            } catch (Exception $e) {

                echo $e;
            }
        }
    }

}
